#!/usr/bin/haserl
<? 
. /usr/lib/webif/webif.sh

dpkg -l phidget22networkserver | grep ^ii 2>&1 1>/dev/null && installed="true" || installed="false"


if [ "$installed" = "true" ]; then

	# Try to find addr that user has typed into brower, other wise fall back on eth0 addr, and finally on wlan0 addr
	_host="${HTTP_REFERER#http://}"
	_host="${_host%%/*}"
	if empty $_host; then
		for ipaddr in $(/sbin/ifconfig | sed -n '/inet addr:/s/ *inet addr:\([[:digit:].]*\) .*/\1/p'); do
			if ! empty "$ipaddr" && ! equal "$ipaddr" "127.0.0.1"; then
				_host="$ipaddr"
				break
			fi
		done
	fi

	load_settings network
	load_settings phidget22networkserver

	hostname=$( hostname )

	if empty "$FORM_submit"; then
		FORM_enabled="$enabled"
		FORM_main_phidgetserver_enable="$main_phidgetserver_enable"
		FORM_phidgetserver_servername="$phidgetserver_servername"
		FORM_phidgetserver_password="$phidgetserver_password"
		FORM_phidgetserver_ipv4_port="$phidgetserver_ipv4_port"
		FORM_main_webserver_enable="$main_webserver_enable"
		FORM_webserver_port="$webserver_port"
	else

		if equal "$FORM_startstop" "Start"; then
			/etc/init.d/phidget22networkserver start 1>/dev/null 2>&1
		elif equal "$FORM_startstop" "Stop"; then
			/etc/init.d/phidget22networkserver stopwait 1>/dev/null 2>&1
		else
			validate <<EOF
string|phidgetserver_servername|Server Name|min=1 max=63 cfg|$FORM_phidgetserver_servername
int|phidgetserver_ipv4_port|Port|required min=1 max=65535 cfg|$FORM_phidgetserver_ipv4_port
int|webserver_port|Port|required min=1 max=65535 cfg|$FORM_webserver_port
password|phidgetserver_password|Password|min=1 max=63 cfg|$FORM_phidgetserver_password
EOF

			equal "$?" 0 && {
				save_setting phidget22networkserver enabled "$FORM_enabled"
				save_setting phidget22networkserver main_phidgetserver_enable "$FORM_main_phidgetserver_enable"
				save_setting phidget22networkserver phidgetserver_password "$FORM_phidgetserver_password"
				save_setting phidget22networkserver phidgetserver_ipv4_port "$FORM_phidgetserver_ipv4_port"
				save_setting phidget22networkserver phidgetserver_servername "$FORM_phidgetserver_servername"
				save_setting phidget22networkserver main_webserver_enable "$FORM_main_webserver_enable"
				save_setting phidget22networkserver webserver_port "$FORM_webserver_port"
				apply_saves
			}
		fi
	fi

fi

if [ "$installed" = "true" ]; then
	header "Phidgets" "phidget22 Network Server" "Phidget22 Network Server" "$SCRIPT_NAME"
else
	header "Phidgets" "phidget22 Network Server" "Phidget22 Network Server"
fi


if [ "$installed" = "true" ]; then
?>
<script type="text/javascript">
/* <![CDATA[ */
function clearServerID()
{
  if(document.getElementById("phidgetserver_servername").value == "<? echo -n "$hostname" ?>")
  {
	document.getElementById("phidgetserver_servername").style.color = "black"
	document.getElementById("phidgetserver_servername").value = ""
  }
}

function resetServerID()
{
  if(document.getElementById("phidgetserver_servername").value == "")
  {
	document.getElementById("phidgetserver_servername").value = "<? echo -n "$hostname" ?>"
	document.getElementById("phidgetserver_servername").style.color = "gray"
  }
}
/* ]]> */
</script>
<?

if [ -z "$FORM_phidgetserver_servername" ]; then
	phidgetserver_servername_form="<input id=\"phidgetserver_servername\" type=\"text\" name=\"phidgetserver_servername\" value=\"$hostname\" style=\"color:gray\" onfocus=\"clearServerID()\" onclick=\"clearServerID()\" onblur=\"resetServerID()\"/>"
else
	phidgetserver_servername_form="<input id=\"phidgetserver_servername\" type=\"text\" name=\"phidgetserver_servername\" value=\"$FORM_phidgetserver_servername\" onfocus=\"clearServerID()\" onclick=\"clearServerID()\" onblur=\"resetServerID()\"/>"
fi


running="Stopped"
ps auxww | grep -v grep | grep -q "\/usr\/bin\/phidget22networkserver " && running="Running"

if equal "$running" "Stopped"; then
	startstop="Network server is <span style=\"color:red\">stopped</span>... <input type=\"submit\" value=\"Start\" name=\"startstop\" />"
else
	startstop="Network server is <span style=\"color:green\">running</span>... <input type=\"submit\" value=\"Stop\" name=\"startstop\" />"
fi

display_form <<EOF
start_form|Phidget Network Server
field|
radio|enabled|$FORM_enabled|true|Enabled
radio|enabled|$FORM_enabled|false|Disabled
field|<br />
field|<h4>Phidget Server Settings</h4>
field|<br />
field|
radio|main_phidgetserver_enable|$FORM_main_phidgetserver_enable|true|Enabled
radio|main_phidgetserver_enable|$FORM_main_phidgetserver_enable|false|Disabled
field|Server ID
string|$phidgetserver_servername_form
field|Port
text|phidgetserver_ipv4_port|$FORM_phidgetserver_ipv4_port
field|Password
text|phidgetserver_password|$FORM_phidgetserver_password
field|<br />
field|<h4>Webserver Settings</h4>
field|<br />
field|
radio|main_webserver_enable|$FORM_main_webserver_enable|true|Enabled
radio|main_webserver_enable|$FORM_main_webserver_enable|false|Disabled
field|Port
text|webserver_port|$FORM_webserver_port
field|<br />
field|
string|$startstop
helpitem|Phidget Server
helptext|The Phidget server enables remote access to Phidgets attached to this SBC.
helpitem|Server Name
helptext|The Server Name is used when connecting to the server by name (mDNS). By default this is the same as the machine hostname.
helpitem|Port
helptext|The port that the server will run on. Default value is 5661.
helpitem|Password
helptext|The password that the server will run with. By default this is blank, and no password will be required.
helpitem|Web Server
helptext|The web server enables access to the Phidget server from web clients via the Javascript API. Available <a href="http://$_host:$webserver_port/" target="_blank">here</a>.
helpitem|Port
helptext|The port that the web server will run on. Default value is 8080.
end_form
EOF

else

	cat <<EOF
The phidget22 network server is not installed. You can install it from the <a href="/cgi-bin/system-packages.sh">Packages</a> page, or via SSH.
EOF

fi

footer ?>

<!--
##WEBIF:name:Phidgets:201:phidget22 Network Server
-->
